/*
 * Vocoder
 *  2012 Achim Settelmeier <vocoder@m1.sirlab.de>
 *
 */

// Includes
#include <string>
#include <stdexcept>
#include <math.h>
#include "outputtrack.h"

using std::string;
using std::runtime_error;


// OutputTrack
OutputTrack::OutputTrack(const string &filename,
			const nframes_t _maxFrames,
			const nframes_t _fps):
	Track(_maxFrames, _fps)
{
	sndFileInfo.samplerate=fps;
	sndFileInfo.channels=2;
	sndFileInfo.format=SF_FORMAT_WAV + SF_FORMAT_PCM_16;
	sndFileFDPtr=sf_open(filename.c_str(), SFM_WRITE, &sndFileInfo);
	
	if(sndFileFDPtr==NULL)
		throw runtime_error(filename + ": " + sf_strerror(NULL));
}

// ~OutputTrack
OutputTrack::~OutputTrack(){
	sf_close(sndFileFDPtr);
}

// writeBlock
nframes_t OutputTrack::writeBlock(const nframes_t numFrames){
	nframes_t numFramesWritten=sf_writef_float(sndFileFDPtr,
						   sampleBufferPtr,
						   numFrames);
	return numFramesWritten;
}
